// MfcDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MfcDemo.h"
#include "MfcDemoDlg.h"
#include "wsNetSendLib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CMfcDemoDlg dlg;

/////////////////////////////////////////////////////////////////////////////
// CMfcDemoDlg dialog

CMfcDemoDlg::CMfcDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMfcDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMfcDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMfcDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMfcDemoDlg)
	DDX_Control(pDX, IDC_BUTTON4, _btn4);
	DDX_Control(pDX, IDC_BUTTON3, _btn3);
	DDX_Control(pDX, IDC_BUTTON2, _btn2);
	DDX_Control(pDX, IDC_BUTTON1, _btn1);
	DDX_Control(pDX, IDC_EDIT1, _edit1);
	DDX_Control(pDX, IDC_EDIT4, _edit4);
	DDX_Control(pDX, IDC_EDIT3, _edit3);
	DDX_Control(pDX, IDC_EDIT2, _edit2);
	DDX_Control(pDX, IDC_RADIO1, _rbtn1);
	DDX_Control(pDX, IDC_RADIO2, _rbtn2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMfcDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CMfcDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_MESSAGE(CM_NEWMSG, OnNewMsg)
	ON_COMMAND(IDC_BUTTON1, OnActivateBtn)
	ON_COMMAND(IDC_BUTTON2, OnDeactivateBtn)
	ON_COMMAND(IDC_BUTTON3, OnExitBtn)
	ON_COMMAND(IDC_BUTTON4, OnSendBtn)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void __stdcall NewMsgCallback(LPCTSTR aFrom, LPCTSTR aTo, LPCTSTR aMsg )
{
	dlg.NewMsg(aFrom, aTo, aMsg);
}

CString GetStateName( int aState )
{
	switch (aState)
	{
		case WSNS_STATE_NONETWORK: return "Network not found";
		case WSNS_STATE_INACTIVE: return "Offline";
		case WSNS_STATE_ACTIVATION: return "Registering...";
		case WSNS_STATE_ACTIVE: return "Online";
		default: return '?';
	};
}

CString GetComputerName()
{
	TCHAR	compName[MAX_COMPUTERNAME_LENGTH + 1] = {0,0};
	DWORD	compNameSize = MAX_COMPUTERNAME_LENGTH + 1;	

	GetComputerName(compName,&compNameSize);
	CharUpper(compName);

	return compName;
}

/////////////////////////////////////////////////////////////////////////////
// CMfcDemoDlg message handlers

BOOL CMfcDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	_edit1.EnableWindow(TRUE);
	_btn1.EnableWindow(TRUE);
	_btn2.EnableWindow(FALSE);
	_btn4.EnableWindow(FALSE);
	_edit2.EnableWindow(FALSE);
	_edit3.EnableWindow(FALSE);
	_rbtn1.EnableWindow(FALSE);
	_rbtn2.EnableWindow(FALSE);
	_edit4.EnableWindow(FALSE);

	InitializeCriticalSection(&msgBufLock);

	NetsendBroadcastInitialize();
	NetsendUnicastInitialize();

	_edit1.SetWindowText( GetComputerName() );
	_rbtn1.SetCheck(1);

	_statusbar = CreateStatusWindow(WS_CHILD|WS_VISIBLE, NULL, *this, 0);
	int w[]= {270,-1};
	::SendMessage(_statusbar, SB_SETPARTS, 2, (long)w );

	SetTimer(0, 1000, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMfcDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMfcDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CMfcDemoDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	NetsendBroadcastDeactivate();
	NetsendUnicastDeactivate();
  
	NetsendBroadcastFinalize();
	NetsendUnicastFinalize();
	
	CDialog::OnClose();
}

BOOL CMfcDemoDlg::PreTranslateMessage(MSG * pMsg)
{
	if ( (GetFocus() == &_edit4) && (pMsg->message == WM_KEYDOWN ) && (pMsg->wParam == VK_ESCAPE))
		return TRUE;
	else if ( (GetFocus() != &_edit4) && (pMsg->message == WM_KEYDOWN ) && (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE))
		return TRUE;
	else
		return CDialog::PreTranslateMessage(pMsg);
}

void CMfcDemoDlg::NewMsg( CString aFrom, CString aTo, CString aMsg )
{
	CMsgBufItem msg;

	msg.from = aFrom;
	msg.addr = aTo;
	msg.msgtext = aMsg;

	EnterCriticalSection(&msgBufLock);
	msgBuf.Add( msg );
	LeaveCriticalSection(&msgBufLock);

	PostMessage(CM_NEWMSG, 0, 0);
}

LRESULT CMfcDemoDlg::OnNewMsg(WPARAM lParam, LPARAM wParam)
{
	CMsgBufItem msg;
	CString hist;

	EnterCriticalSection(&msgBufLock);

	for (int i=0; i<msgBuf.GetSize();++i)
	{
		msg = msgBuf[i];
		_edit2.GetWindowText(hist);

		hist += "From: " + msg.from + "\r\n";
		hist += "To: "  + msg.addr + "\r\n";
		hist += msg.msgtext + "\r\n";
		hist += "\r\n";

		_edit2.SetWindowText(hist);
		_edit2.SetSel(hist.GetLength(), hist.GetLength());
	};
	msgBuf.RemoveAll();
  
	LeaveCriticalSection(&msgBufLock);

	return 0;
}

void CMfcDemoDlg::OnActivateBtn()
{
	CString addr;

	_edit1.GetWindowText(addr);

	NetsendBroadcastSetOnNewMsg( NewMsgCallback );
	NetsendBroadcastActivate();

	NetsendUnicastAddName( addr );
	NetsendUnicastSetOnNewMsg( NewMsgCallback );
//	NetsendUnicastSetSendTimeout(1000);
	NetsendUnicastActivate();

	_edit1.EnableWindow(FALSE);
	_btn1.EnableWindow(FALSE);
	_btn2.EnableWindow(TRUE);
	_btn4.EnableWindow(TRUE);
	_edit2.EnableWindow(TRUE);
	_edit3.EnableWindow(TRUE);
	_rbtn1.EnableWindow(TRUE);
	_rbtn2.EnableWindow(TRUE);
	_edit4.EnableWindow(TRUE);
}

void CMfcDemoDlg::OnDeactivateBtn()
{
	NetsendBroadcastDeactivate();
	NetsendUnicastDeactivate();

	_edit1.EnableWindow(TRUE);
	_btn1.EnableWindow(TRUE);
	_btn2.EnableWindow(FALSE);
	_btn4.EnableWindow(FALSE);
	_edit2.EnableWindow(FALSE);
	_edit3.EnableWindow(FALSE);
	_rbtn1.EnableWindow(FALSE);
	_rbtn2.EnableWindow(FALSE);
	_edit4.EnableWindow(FALSE);
}

void CMfcDemoDlg::OnSendBtn()
{
	int r;
	CString addr, msg, sign;

	_edit1.GetWindowText(sign);
	_edit3.GetWindowText(addr);
	_edit4.GetWindowText(msg);

	if ( _rbtn1.GetCheck() ) 
		r = NetsendUnicastSendMsgEx( addr, msg, sign );
	else
		r = NetsendBroadcastSendMsgEx( addr, msg, sign );

	if ( r != WSNS_RESULT_SUCCESS ) 
		MessageBox(_T("Unknown error"), _T("Error"), MB_OK);
	else
		_edit4.SetWindowText(_T(""));
}

void CMfcDemoDlg::OnExitBtn()
{
	SendMessage(WM_CLOSE, 0, 0);
}

void CMfcDemoDlg::OnTimer( UINT nIDEvent )
{
	DWORD stateb, stateu;
	CString stnameu, stnameb, txt;
	CString addr;

	_edit1.GetWindowText(addr);

	if ( NetsendUnicastGetState( addr, &stateu ) == WSNS_RESULT_SUCCESS ) 
	{
		stnameu = GetStateName(stateu);
		txt = "Personal name (" + addr + ") - " + stnameu; 

		::SendMessage( _statusbar, SB_SETTEXT, 0, (long)(LPCTSTR)txt);
	};

	if ( NetsendBroadcastGetState( &stateb ) == WSNS_RESULT_SUCCESS ) 
	{
		stnameb = GetStateName(stateb);
		txt = "Group name (*) - " +stnameb;

		::SendMessage( _statusbar, SB_SETTEXT, 1, (long)(LPCTSTR)txt);
	};
}

